/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package code2html;

import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author mpd209
 */
public class PhPParser extends Parser {

    public PhPParser(String inFile, String outFile) throws IOException {
        super(inFile, outFile);
    }




    
    @Override
    protected String convert(String contents) {
        String html = contents;
        html = Pattern.compile("\\&").matcher(html).replaceAll("&amp;");
        html = Pattern.compile("\\<").matcher(html).replaceAll("&lt;");
        html = Pattern.compile("\\>").matcher(html).replaceAll("&gt;");
        html = Pattern.compile("\\n").matcher(html).replaceAll("<br/>\n");
        html = Pattern.compile("\\t").matcher(html).replaceAll("&nbsp;&nbsp;&nbsp;&nbsp;");
        html = Pattern.compile(" {2}").matcher(html).replaceAll("&nbsp;&nbsp;");
        html = doubleQuotesSpan("php_doublequotes", html);
        html = singleQuotesSpan("php_singlequotes", html);
        html = keywordSpan("class", "php_class", html, true);
        html = keywordSpan("return", "php_return", html);
        html = keywordSpan("public", "php_public", html);
        html = keywordSpan("private", "php_private", html);
        html = keywordSpan("function", "php_function", html);
        html = keywordSpan("protected", "php_protected", html);
        html = keywordSpan("static", "php_static", html);
        html = keywordSpan("switch", "php_switch", html);
        html = keywordSpan("case", "php_case", html);
        html = keywordSpan("break", "php_break", html);
        html = keywordSpan("default", "php_default", html);
        html = functionSpan("php_functionname", html);
        html = bigCommentSpan("\\/\\*", "\\*\\/", "php_bigcomment", html);
        html = lineCommentSpan("\\/\\/", "php_linecomment", html);

        String regex = "(\\$\\w\\w*)";
        Pattern p = Pattern.compile(regex);
        Matcher m = p.matcher(html);
        StringBuffer sb = new StringBuffer();
        String match;
        while (m.find()) {
            match = m.group(1).replaceAll("\\$", "\\\\\\$");
            if(!inString(m.start(), html)){
                m.appendReplacement(sb, "<span class=\"php_variable\">" + match + "</span>");
            }
        }
        m.appendTail(sb);
        html = sb.toString();

        
//        System.out.println("contents IS "+contents);
//        System.out.println("HTML IS "+html);
        return html;
    }
}
