from matplotlib.pyplot import *
from matplotlib import *
from matplotlib.transforms import *
from pylab import *
from numpy import *
from matplotlib.colors import *
def getColourList(N, colourMap='jet'):
	"""
	Generate N hex colours from the Jet colour map. The first and last few colours
	may make black text unreadable, so sample 20% more colours than are needed
	and strip away the first and last 10%.
	"""
	cmap = getattr(cm, colourMap)
	idx = linspace(0, 255, N + (N * 0.2)).astype(int)
	colors = cmap(idx)
	colList = colors.tolist()
	del colList[:int(N*0.1)]
	del colList[len(colList)-int(N * 0.1):]
	hexCodes = []
	for i in range(len(colList)):
		hexCodes.append(rgb2hex(colList[i][:3]))
	return hexCodes


figure(num=None, figsize=(12, 10), dpi=80, facecolor='w', edgecolor='k')

values = array([
[5.8246067E10,9.40505E8,2.030717E9,1.317038E9,1.39503E8,1.6864868E10,4.894157E9,4.292573E9,3.0297297E10,6.7534734E10,1.518171E9,2.283714E10,7.138682E9,1.48586E8,9.11396E8],
[2.0,47.0,44.0,42.0,51.0,10.0,25.0,26.0,4.0,2.0,51.0,7.0,18.0,51.0,51.0]
])
timewithout = 2.67561768E11
alllabels = ['[0]','[1]','[2]','[3]','[4]','[5]','[6]','[7]','[8]','[9]','[10]','[11]','[12]','[13]','[14]']

pointMarkers=['o','s','^','>','v','<','d','p','h','8']
colours=getColourList(values.shape[1], "Accent")
marks=[]
labels=[]
for d in range(values.shape[1]):
	m = d % len(pointMarkers)
	#print d,colours[d],pointMarkers[m]
	marks.append(scatter(values[1,d], values[0,d], s=100, c=colours[d], marker=pointMarkers[m]))
	labels.append(alllabels[d])
ylabel('Total Time Taken (ns)', size="x-large")
xlabel('Total Error (Symmetric Area Diff.) (units^2)', size="x-large")
xmin, xmax = xlim()
x = arange(0, xmax+1)
y = (0*x) + timewithout

marks.append(plot(x, y, 'r-'))
labels.append("W/o Change Identifiers")
#print xlim()
#print xmax
xlim(0, xmax)
#print xlim()
lgnd = legend(marks, labels, bbox_to_anchor=(1.05, 1), loc=2, borderaxespad=0.)
title('Time Taken vs Error for Generation 0 Using the\nExtent_Cardinality_Expand_Noisy_500d_500p Pattern\nand the Chi-hull Algorithm (inc. Timestep Identifier)', size="x-large")
savefig('genWithTimestepCounter[00].png', bbox_inches=Bbox.from_bounds(0, 0, 15, 10.5))
show()
