from matplotlib.pyplot import *
from matplotlib import *
from matplotlib.transforms import *
from pylab import *
from numpy import *
from matplotlib.colors import *
def getColourList(N, colourMap='jet'):
	"""
	Generate N hex colours from the Jet colour map. The first and last few colours
	may make black text unreadable, so sample 20% more colours than are needed
	and strip away the first and last 10%.
	"""
	cmap = getattr(cm, colourMap)
	idx = linspace(0, 255, N + (N * 0.2)).astype(int)
	colors = cmap(idx)
	colList = colors.tolist()
	del colList[:int(N*0.1)]
	del colList[len(colList)-int(N * 0.1):]
	hexCodes = []
	for i in range(len(colList)):
		hexCodes.append(rgb2hex(colList[i][:3]))
	return hexCodes


figure(num=None, figsize=(12, 10), dpi=80, facecolor='w', edgecolor='k')

values = array([
[1.8535692E10,3.521697E9,1.862136E10,1.050327E10,2.54016213E11,2.4061419E10,4.199363E9,8.508481E9,9.21578E8,8.519782E9,2.4638907E10,3.152991E9,1.861949E9,5.88249E8,9.969438E9],
[4.0,16.0,4.0,7.0,0.0,3.0,15.0,10.0,31.0,10.0,3.0,19.0,25.0,32.0,8.0]
])
alllabels = ['[578]','[838]','[1021]','[1918]','[2492]','[2747]','[2928]','[2929]','[2996]','[2998]','[2999]','[3053]','[3056]','[3059]','[3061]']
timewithout = 2.67561768E11

pointMarkers=['o','s','^','>','v','<','d','p','h','8']
colours=getColourList(values.shape[1], "Accent")
marks=[]
labels=[]
for d in range(values.shape[1]):
	m = d % len(pointMarkers)
	#print d,colours[d],pointMarkers[m]
	marks.append(scatter(values[1,d], values[0,d], s=100, c=colours[d], marker=pointMarkers[m]))
	labels.append(alllabels[d])
ylabel('Total Time Taken (ns)', size="x-large")
xlabel('Total Error (Symmetric Area Diff.) (units^2)', size="x-large")
xmin, xmax = xlim()
x = arange(0, xmax+1)
y = (0*x) + timewithout

marks.append(plot(x, y, 'r-'))
labels.append("W/o Change Identifiers")
#print xlim()
#print xmax
xlim(0, xmax)
#print xlim()
lgnd = legend(marks, labels, bbox_to_anchor=(1.05, 1), loc=2, borderaxespad=0.)
title('Time Taken vs Error for Generation 49 Using the\nExtent_Cardinality_Expand_Noisy_500d_500p Pattern\nand the Chi-hull Algorithm (inc. Timestep Identifier)', size="x-large")
savefig('genWithTimestepCounter[49].png', bbox_inches=Bbox.from_bounds(0, 0, 15, 10.5))
show()
