from matplotlib.pyplot import *
from matplotlib import *
from matplotlib.transforms import *
from pylab import *
from numpy import *
from matplotlib.colors import *
def getColourList(N, colourMap='jet'):
	"""
	Generate N hex colours from the Jet colour map. The first and last few colours
	may make black text unreadable, so sample 20% more colours than are needed
	and strip away the first and last 10%.
	"""
	cmap = getattr(cm, colourMap)
	idx = linspace(0, 255, N + (N * 0.2)).astype(int)
	colors = cmap(idx)
	colList = colors.tolist()
	del colList[:int(N*0.1)]
	del colList[len(colList)-int(N * 0.1):]
	hexCodes = []
	for i in range(len(colList)):
		hexCodes.append(rgb2hex(colList[i][:3]))
	return hexCodes
figure(num=None, figsize=(12, 10), dpi=80, facecolor='w', edgecolor='k')
gcf().subplots_adjust(hspace=0.5)
colourlist = getColourList(20, "Accent")

x = linspace(0, 100, 75)
y = 100*exp(-x/25.0)
plot(x, y, ms=0.0, c='blue', marker='', ls='-', lw=2.0)
#fill(x, y, facecolor='blue', alpha=0.5)
fill_between(x,y,100,color='#87CEFF')

#

ylabel('Time Taken per Timestep (ns)', size='x-large')
xlabel('Error (Symmetric Area Diff.) per Timestep (units^2)', size='x-large')
xmin, xmax = xlim()
xlim(0,xmax)
title('Possible Solution Space', size='x-large')
savefig('possible-solution-space.png', bbox_inches=Bbox.from_bounds(0, 0, 12, 10))#, bbox_inches=Bbox.from_bounds(0, -22, 12, 28.5), bbox_extra_artists=[lgnd.legendPatch])
show()
