from matplotlib.pyplot import *
from matplotlib import *
from matplotlib.transforms import *
from pylab import *
from numpy import *
from matplotlib.colors import *
def getColourList(N, colourMap='jet'):
	"""
	Generate N hex colours from the Jet colour map. The first and last few colours
	may make black text unreadable, so sample 20% more colours than are needed
	and strip away the first and last 10%.
	"""
	cmap = getattr(cm, colourMap)
	idx = linspace(0, 255, N + (N * 0.2)).astype(int)
	colors = cmap(idx)
	colList = colors.tolist()
	del colList[:int(N*0.1)]
	del colList[len(colList)-int(N * 0.1):]
	hexCodes = []
	for i in range(len(colList)):
		hexCodes.append(rgb2hex(colList[i][:3]))
	return hexCodes

figure(num=None, figsize=(12, 10), dpi=80, facecolor='w', edgecolor='k')
#rcParams['xtick.major.size'] = 5
#rcParams['xtick.minor.size'] = 3
#p.tick_params(axis="x", which="minor", labelsize="large")
def tform(x, y, T):
	valuepairs = []
	for i in range(len(x)):
		valuepairs.append([x[i],y[i]])
	for i in range(len(valuepairs)):
		transformed = matrix([valuepairs[i][0],valuepairs[i][1]])*T
		valuepairs[i] = [transformed[0,0], transformed[0,1]]
	return array(valuepairs)

x = arange(0, 100, 17)
y = 100*exp(-x/25.0)

#R = matrix([[0, 1],[-1,0]])
#values = tform(x,y,R)
colours = getColourList(len(x), "Accent")
for i in range(len(x)):
	scatter(x[i], y[i], s=100, c=colours[i % len(x)], marker='o', label="Set "+str(i+1))

legend(bbox_to_anchor=(1.05, 1), loc=2, borderaxespad=0.)

title("Time against Error", size='x-large')
ylabel('Time Taken', size='x-large')
xlabel('Error', size='x-large')

#
#xticks( arange(1,21) )
#x = range(1,21)
#lines = []
#lines.append(plot(x, values[:,0], ms=10.0, c='#87CEFF', marker='o', ls='-', lw=2.0))
#lines.append(plot(x, values[:,1], ms=10.0, c='r', marker='d', ls='--', lw=2.0))
#xlabel('Timestep')
#ylabel('Computation Time')
#xlim(1,20)
#lgnd = legend(lines, ('With Change Identifiers', 'Without Change Identifiers'), bbox_to_anchor=(0.5, -0.05), loc=9, borderaxespad=0.)
#title('Time Taken per Timestep')

savefig('timevserror_example.png', bbox_inches=Bbox.from_bounds(0, 0, 14, 10))#, bbox_inches=Bbox.from_bounds(0, -22, 12, 28.5), bbox_extra_artists=[lgnd.legendPatch])
show()
