from matplotlib.pyplot import *
from matplotlib import *
from matplotlib.transforms import *
from pylab import *
from numpy import *
from matplotlib.colors import *
import matplotlib.pyplot as p
def getColourList(N, colourMap='jet'):
	"""
	Generate N hex colours from the Jet colour map. The first and last few colours
	may make black text unreadable, so sample 20% more colours than are needed
	and strip away the first and last 10%.
	"""
	cmap = getattr(cm, colourMap)
	idx = linspace(0, 255, N + (N * 0.2)).astype(int)
	colors = cmap(idx)
	colList = colors.tolist()
	del colList[:int(N*0.1)]
	del colList[len(colList)-int(N * 0.1):]
	hexCodes = []
	for i in range(len(colList)):
		hexCodes.append(rgb2hex(colList[i][:3]))
	return hexCodes

figure(num=None, figsize=(12, 10), dpi=80, facecolor='w', edgecolor='k')
values = array([
[3710854,22402136,7779824],
[50.0,14.0,23.0]
])

colourlist = getColourList(20, "Accent")

scatter(values[1,2], values[0,2], s=100, c=colourlist[10], marker='o', label="NEARESTNEIGHBOURDIST-0.1")
scatter(values[1,0], values[0,0], s=100, c=colourlist[10], marker='>', label="NEARESTNEIGHBOURDIST-0.25")
scatter(values[1,1], values[0,1], s=100, c='#87CEFF', marker='d', label="UserSelected-0.33")
ylabel('Average Time Taken per Timestep (ns)', size='x-large')
xlabel('Average Error (Symmetric Area Diff.) per Timestep (units^2)', size='x-large')
xmin, xmax = xlim()
x = np.arange(xmax+1)
y = (0*x) + 498097078
semilogy()
plot(x, y, 'r-', c='r', marker='', ls='-', lw=2.0, label = ("W/o Change Identifiers - % G" % 498097078))
xlim(xmin, xmax)
#ylim(0, 2.495817991E11)
#lgnd = legend(markerCollections, ('NEARESTNEIGHBOURDIST-0.25','UserSelected-0.25','NEARESTNEIGHBOURDIST-0.1', 'Tnci'), bbox_to_anchor=(1.05, 1), loc=2, borderaxespad=0.)
legend(bbox_to_anchor=(1.05, 1), loc=2, borderaxespad=0.)
title('Average Time Taken per Timestep vs Average Error per Timestep\nShowing a User Defined Set on\n Extent_Cardinality_Expand_Noisy_500d_500pUsing Chi-hull', size='x-large')
savefig('timetakenVsError_perstep_userset-extent-card-expand-noisy-chihull.png',bbox_inches=Bbox.from_bounds(0, 0, 18, 10))
show()
