<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html>

    <head>

        <?php include('template-parts/meta.part.php'); ?>

        <link rel="stylesheet" href="/css/gcode.css" media="print, screen"/>

        <link rel="stylesheet" href="/css/academic.css" media="print, screen"/>

        <?php

        $showCurrentWork = (Authorisation::isAuthorised("academic.page.view")&&($GLOBALS['CURRENT_PAGE']->getUri()=="academic/work"));

        ?>

        <?php _part("template-parts/google-analytics.part.php");?>

    </head>

    <body>

        <div id="page">

                    <?php include('template-parts/header.part.php'); ?>

            <div id="columns">

                <div id="left_column">

                    <p>

                    <?php if(isset($contents['content'])&&$contents['content']!=NULL)$contents['content']->evaluate(); ?>

                    </p>

                        <?php

                            function addDoc($title, $path,  $sourcepath=null,  $flagged=false, $desc=null){

                                $html = "<li class=\"doc".($flagged?" flagged":"")."\">\n";

                                $html .= "\t<span class=\"doc_last_updated\">";

                                $file = File::getFileByUri("academic/".$path);

                                $html .= date("d M Y H:i", $file->getUploaded());

                                $html .= "</span>\n";

                                $html .= "\t<span class=\"doc_title\">".$title."</span>\n";

                                $html .= "\t<a class=\"doc_pdf\" target=\"_blank\" href=\"/uploads/academic/".$path."\" title=\"".$title."\">PDF</a>\n";

                                if($sourcepath!=null){

                                    $html .= "\t<a class=\"doc_source\" href=\"/uploads/academic/".$sourcepath."\" title=\"".$title." - SOURCE\">SOURCE</a>\n";

                                }

                                if($desc!=null){

                                    $html .= "\t<p class=\"doc_desc\">\n";

                                    $html .= "\t\t".$desc;

                                    $html .= "\t</p>\n";

                                }

                                $html .= "</li>\n";

                                echo $html;

                            }

                        ?>

                    <?php

                    if($showCurrentWork){?>

                    <h3 class="current_work">Current work:</h3>

                    <p>Listing of current documents, ongoing or finished. Flagged items are ones currently being worked on.</p>

                    <ul class="doc_list">

                    <?php





                            addDoc("Paper for COSIT2011", "documents/COSIT2011.pdf",

                                "documents/sources/COSIT2011.zip", true,

                                "Paper for COSIT2011");



                            addDoc("Change Identifiers", "documents/ChangeIdentifiers.pdf",

                                "documents/sources/ChangeIdentifiers.zip", false,

                                "Description of the intentions and ideas about change identifier construction and use");



                            addDoc("Change Identifiers Listing", "documents/ChangeIdentifiersListing.pdf",

                                "documents/sources/ChangeIdentifiersListing.zip", false,

                                "(Incomplete) Listing of change identifiers with pseudo-code and complexities.");



                            addDoc("Engine Design", "documents/EngineDesignDocumentation.pdf",

                                "documents/sources/EngineDesignDocumentation.zip", false,

                                "Explanation of the framework design and how it's been kept modular");



                            addDoc("Academic CV", "documents/AcademicCV.pdf",

                                "documents/sources/AcademicCV.zip", false,

                                "Academic curriculum vitae, quite small at the moment, will probably need extension.");





                            addDoc("Dynamics", "documents/Dynamics.pdf",

                                "documents/sources/Dynamics.zip", false,

                                "Thoughts on dynamic dot patterns");



                            addDoc("Dynamics Background", "documents/DynamicsBackground.pdf",

                                "documents/sources/DynamicsBackground.zip", false,

                                "Some preliminary research into existing work on dynamic dot patterns");





                            addDoc("Literature Review", "documents/LiteratureReview.pdf",

                                "documents/sources/LiteratureReview.zip", false,

                                "Old literature review, will need to be combined with stuff from COSIT paper");



                    ?>

                    </ul>







                    <h3 class="current_work">Thesis Parts:</h3>

                    <p>Chapters of the thesis. Flagged items are ones currently being worked on.</p>

                    <ul class="doc_list">

                        <?php

                            addDoc("Introduction", "thesis/introduction.pdf",

                                "thesis/sources/introduction.tex");



                            addDoc("Background", "thesis/background.pdf",

                                "thesis/sources/background.tex", true);



                            addDoc("Footprint and Dot Patterns", "thesis/footprint-and-dot-patterns.pdf",

                                "thesis/sources/footprint-and-dot-patterns.tex");



                            addDoc("Change Identifiers", "thesis/change-identifiers.pdf",

                                "thesis/sources/change-identifiers.tex");



                            addDoc("Application Framework", "thesis/framework.pdf",

                                "thesis/sources/framework.tex");



                            addDoc("Results", "thesis/results.pdf",

                                "thesis/sources/results.tex");



                            addDoc("Minimisation and Optimisation", "thesis/minimisation-optimisation.pdf",

                                "thesis/sources/minimisation-optimisation.tex");



                            addDoc("Optimal Parameter Selection", "thesis/optimal-parameter.pdf",

                                "thesis/sources/optimal-parameter.tex");



                            addDoc("Shape Information", "thesis/shape-information.pdf",

                                "thesis/sources/shape-information.tex");



                            addDoc("Conclusions", "thesis/conclusions.pdf",

                                "thesis/sources/conclusions.tex");



                            addDoc("[ALL] Thesis", "thesis/Thesis.pdf",

                                "thesis/sources/Thesis.zip", false,

                                "To create individual pdf's use pdflatex -jobname=[chapter name]"

                                ." main. Can also use batch or shell scripts from scripts folder");

                        ?>

     

                    </ul>

                    <?php }?>

                    <style type="text/css">

                        ul.publications{

                           margin: 0px;

                           padding: 0px;

                           border: 1px solid #ccc;

                        }

                        ul.publications ul.publications{

                           border: none !important;

                        }

                        ul.publications li{

                            list-style-type: none;

                            margin: 10px;

                            padding: 0px;

                        }

                        ul.publications li.flagged{

                            list-style-image: url('/images/icons/flagged_8x8.png');

                            list-style-position:inside;

                            margin: 10px;

                            padding: 0px;

                        }

                        ul.publications li.year{

                            margin: 5px !important;

                        }

                        ul.publications span.year{

                            font: normal normal bold 10pt Monospace;

                        }

                        ul.publications span.title{

                            font-style: italic;

                        }

                        ul.publications span.authors{

                        }

                        ul.publications span.conference{

                            font-size: 8pt;

                        }

                        ul.publications span.workshop{

                            font-size: 8pt;

                        }

                        ul.publications a, ul.publications a:visited{

                            font-family: Monospace;

                            text-transform: uppercase !important;

                            font-size: 1.1em;

                            color: #333;

                            border-bottom: 1px dashed #333;

                        }

                        ul.publications a:hover, ul.publications a:visited:active{

                            color: #666;

                            border-bottom: 1px dashed #666;

                        }

                    </style>

                    <?php



                    class Publication{

                        public $title,  $pdf, $source, $year, $conference, $workshop, $flagged;

                        public $authors = array("Maximillian Dupenois");





                        public function html($showCurrentWork){

                            $html = "<li class=\"publication".($showCurrentWork&&$this->flagged?" flagged":"")."\">\n";

                            $html .= "\t<span class=\"title\">".$this->title."</span>\n";

                            $html .= "\t<span class=\"authors\">";

                            for($i=0; $i<count($this->authors); $i++){

                                if($i ==  count($this->authors)-1){

                                    $html .= " and ";

                                }else if($i!=0){

                                    $html .= ", ";

                                }

                                $html .= $this->authors[$i];

                            }

                            $html .= "</span>\n";

                            if($this->workshop!=null){

                                $html .= "\t<span class=\"workshop\">".$this->workshop."</span>\n";

                            }

                            $html .= "\t<span class=\"conference\">".$this->conference."</span>\n";

                            $html .= "<a class=\"pdf\" href=\"/uploads/academic/".$this->pdf."\"

                                       title=\"".$this->title."\">PDF</a>\n";

                            if($showCurrentWork){

                                $html .= "<a class=\"source\" href=\"/uploads/academic/".$this->source."\"

                                           title=\"".$this->title." - SOURCE\">Source</a>\n";

                            }

                            $html .= "</li>";

                            return $html;

                        }

                    }



                    class Publications{

                        private $publications = array();

                        public function add($publication){

                            if(!isset($this->publications[$publication->year])||!is_array($this->publications[$publication->year])){

                                $this->publications[$publication->year] = array();

                            }

                            $this->publications[$publication->year][] = $publication;

                        }

                        public function html($showCurrentWork){

                            foreach($this->publications as $year=>$pubs){

                                $html = "<ul class=\"publications\">\n";

                                $html .= "\t<li class=\"year\">\n";

                                $html .= "\t<span class=\"year\">".$year."</span>\n";

                                foreach($pubs as $p){

                                    $html .=  $p->html($showCurrentWork);

                                }

                                $html .= "\t</li>\n";

                                $html .= "</ul>\n";

                            }

                            return $html;

                        }

                        

                    }

                    $conferences = new Publications();

                    $workshops = new Publications();



                    $cosit2009 = new Publication();

                    $cosit2009->title= "Assigning Footprints to Dot Sets An Analytical Survey";

                    $cosit2009->year = 2009;

                    $cosit2009->authors[] = "Antony Galton";

                    $cosit2009->conference = "COSIT 2009";

                    $cosit2009->pdf = "papers/COSIT2009.pdf";

                    $cosit2009->source = "papers/sources/COSIT2009.zip";

                    $conferences->add($cosit2009);



                    $ecai2010 = new Publication();

                    $ecai2010->title= "The Use of Change Identifiers to Update Footprints of Dot Patterns in Real Time";

                    $ecai2010->year = 2010;

                    $ecai2010->authors[] = "Antony Galton";

                    $ecai2010->conference = "ECAI 2010";

                    $ecai2010->workshop = "STeDy";

                    $ecai2010->pdf = "papers/ECAI2010.pdf";

                    $ecai2010->source = "papers/sources/ECAI2010.zip";

                    $workshops->add($ecai2010);



                    ?>

                    <h3 class="papers_header">Conferences:</h3>

                    <p>Chronological list of papers<?php if($showCurrentWork){echo" with sources attached";}?> presented at conferences.</p>

                    <?php echo $conferences->html($showCurrentWork); ?>

                    <h3 class="papers_header">Workshops:</h3>

                    <p>Chronological list of workshops presented at with the presented work:</p>

                    <?php echo $workshops->html($showCurrentWork); ?>

                     <?php if($showCurrentWork){include('template-parts/googlecoderss.part.php');} ?>

                </div>

                <div id="right_column">

                    <?php include('template-parts/links.part.php'); ?>

                </div>

                <div class="clear"><!--clear--></div>

            </div>

                    <?php include('template-parts/footer.part.php'); ?>
        </div>

    </body>

</html>